Module | Sequel::Plugins::NestedAttributes::ClassMethods
In: | lib/sequel/plugins/nested_attributes.rb

### Methods

nested_attributes

### Attributes

nested_attributes_module | [RW] | Module to store the nested_attributes setter methods, so they can call be overridden and call super to get the default behavior

### Public Instance methods

nested_attributes(*associations, &block)

Allow nested attributes to be set for the given associations. Options:

- :destroy - Allow destruction of nested records.
- :fields - If provided, should be an Array or proc. If it is an array, restricts the fields allowed to be modified through the association_attributes= method to the specific fields given. If it is a proc, it will be called with the associated object and should return an array of the allowable fields.
- :limit - For *_to_many associations, a limit on the number of records that will be processed, to prevent denial of service attacks.
- :reject_if - A proc that is given each attribute hash before it is passed to its associated object. If the proc returns a truthy value, the attribute hash is ignored.
- :remove - Allow disassociation of nested records (can remove the associated object from the parent object, but not destroy the associated object).
- :strict - Kept for backward compatibility. Setting it to false is equivalent to setting :unmatched_pk to :ignore.
- :transform - A proc to transform attribute hashes before they are passed to associated object. Takes two arguments, the parent object and the attribute hash. Uses the return value as the new attribute hash.
- :unmatched_pk - Specify the action to be taken if a primary key is provided in a record, but it doesn‘t match an existing associated object. Set to :create to create a new object with that primary key, :ignore to ignore the record, or :raise to raise an error. The default is :raise.

If a block is provided, it is used to set the :reject_if option.

[Source]

         # File lib/sequel/plugins/nested_attributes.rb, line 110
    110:         def nested_attributes(*associations, &block)
    111:           include(self.nested_attributes_module ||= Module.new) unless nested_attributes_module
    112:           opts = associations.last.is_a?(Hash) ? associations.pop : {}
    113:           reflections = associations.map{|a| association_reflection(a) || raise(Error, "no association named #{a} for #{self}")}
    114:           reflections.each do |r|
    115:             r[:nested_attributes] = opts
    116:             r[:nested_attributes][:unmatched_pk] ||= opts.delete(:strict) == false ? :ignore : :raise
    117:             r[:nested_attributes][:reject_if] ||= block
    118:             def_nested_attribute_method(r)
    119:           end
    120:         end

[Validate]